heat_template_version: pike

description: >
  OpenStack containerized Ironic PXE service

parameters:
  DockerIronicPxeImage:
    description: image
    type: string
  DockerIronicConfigImage:
    description: The container image to use for the ironic config_volume
    type: string
  EndpointMap:
    default: {}
    description: Mapping of service endpoint -> protocol. Typically set
                 via parameter_defaults in the resource registry.
    type: json
  ServiceData:
    default: {}
    description: Dictionary packing service data
    type: json
  ServiceNetMap:
    default: {}
    description: Mapping of service_name -> network name. Typically set
                 via parameter_defaults in the resource registry.  This
                 mapping overrides those in ServiceNetMapDefaults.
    type: json
  DefaultPasswords:
    default: {}
    type: json
  RoleName:
    default: ''
    description: Role name on which the service is applied
    type: string
  RoleParameters:
    default: {}
    description: Parameters specific to the role
    type: json
  UpgradeRemoveUnusedPackages:
    default: false
    description: Remove package if the service is being disabled during upgrade
    type: boolean

resources:

  ContainersCommon:
    type: ./containers-common.yaml

outputs:
  role_data:
    description: Role data for the Ironic PXE role.
    value:
      service_name: ironic_pxe
      config_settings: {}
      step_config: &step_config ''
      service_config_settings: {}
      # BEGIN DOCKER SETTINGS
      puppet_config:
        config_volume: ironic
        puppet_tags: ironic_config
        step_config: *step_config
        config_image: {get_param: DockerIronicConfigImage}
      kolla_config:
        /var/lib/kolla/config_files/ironic_pxe_http.json:
          command: /usr/sbin/httpd -DFOREGROUND
          config_files:
            - source: "/var/lib/kolla/config_files/src/*"
              dest: "/"
              merge: true
              preserve_properties: true
          permissions:
            - path: /var/log/ironic
              owner: ironic:ironic
              recurse: true
            - path: /var/lib/ironic
              owner: ironic:ironic
              recurse: true
        /var/lib/kolla/config_files/ironic_pxe_tftp.json:
          command: /usr/sbin/in.tftpd --foreground --user root --address 0.0.0.0:69 --map-file /var/lib/ironic/tftpboot/map-file /var/lib/ironic/tftpboot
          config_files:
            - source: "/var/lib/kolla/config_files/src/*"
              dest: "/"
              merge: true
              preserve_properties: true
          permissions:
            - path: /var/log/ironic
              owner: ironic:ironic
              recurse: true
            - path: /var/lib/ironic
              owner: ironic:ironic
              recurse: true
      upgrade_tasks:
        - when: step|int == 0
          tags: common
          block:
            - name: drop tftp from xinetd supervision
              file:
                path: /etc/xinetd.d/tftp
                state: absent
            - name: restart xinetd in order to free tftp port
              service:
                name: xinetd
                state: restarted
        - when: step|int == 3
          block:
            - name: Set fact for removal of tftp-server package
              set_fact:
                remove_tftp_server: {get_param: UpgradeRemoveUnusedPackages}
            - name: remove tftp-server if requested
              ignore_errors: True
              when: remove_tftp_server|bool
              package:
                name: tftp-server
                state: removed
      docker_config:
        step_4:
          ironic_pxe_tftp:
            start_order: 90
            image: &ironic_pxe_image {get_param: DockerIronicPxeImage}
            net: host
            privileged: false
            restart: always
            volumes:
              list_concat:
                - {get_attr: [ContainersCommon, volumes]}
                -
                  - /var/lib/kolla/config_files/ironic_pxe_tftp.json:/var/lib/kolla/config_files/config.json:ro
                  - /var/lib/config-data/puppet-generated/ironic/:/var/lib/kolla/config_files/src:ro
                  - /var/lib/ironic:/var/lib/ironic/:shared
                  - /dev/log:/dev/log
                  - /var/log/containers/ironic:/var/log/ironic
                  - /var/log/containers/httpd/ironic-pxe:/var/log/httpd
            environment:
              - KOLLA_CONFIG_STRATEGY=COPY_ALWAYS
          ironic_pxe_http:
            start_order: 91
            image: *ironic_pxe_image
            net: host
            privileged: false
            restart: always
            volumes:
              list_concat:
                - {get_attr: [ContainersCommon, volumes]}
                -
                  - /var/lib/kolla/config_files/ironic_pxe_http.json:/var/lib/kolla/config_files/config.json:ro
                  - /var/lib/config-data/puppet-generated/ironic/:/var/lib/kolla/config_files/src:ro
                  - /var/lib/ironic:/var/lib/ironic/:shared
                  - /var/log/containers/ironic:/var/log/ironic
                  - /var/log/containers/httpd/ironic-pxe:/var/log/httpd
            environment:
              - KOLLA_CONFIG_STRATEGY=COPY_ALWAYS
      host_prep_tasks:
        - name: create persistent directories
          file:
            path: "{{ item }}"
            state: directory
          with_items:
            - /var/lib/ironic
            - /var/log/containers/ironic
            - /var/log/containers/httpd/ironic-pxe
        - name: ironic logs readme
          copy:
            dest: /var/log/ironic/readme.txt
            content: |
              Log files from ironic containers can be found under
              /var/log/containers/ironic and /var/log/containers/httpd/ironic-*.
          ignore_errors: true
